/*
(C)2000 Piotr Gapinski
FREEWARE

TODO
1. reagowanie na znacznik \plain
2. reagowanie na znacznik zagniedzenia {, }
3. reagowanie na znaczniki \i0 \b0 \ul0
*/

#include "stdafx.h"
#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#define NONE ""
void parse(char *, int);

FILE *in=NULL, *out=NULL;
long line=0, level=0;
char *levels[2000] = { NULL };

#define HTML
int main(int argc, char* argv[])
{
	long size=0, rsize;
	char *buff=NULL, *tmp=NULL; 

	in  = fopen("c:\\collins\\dict201.dat", "rb");
	out = fopen("c:\\collins\\201.html", "w");
	if (in && out) {
		while (!feof(in)) {
			// struktura pliku wejsciowego jest prosta, najpierw jest licznik (4 bajty)
			// dugosci danych a po nim dane
			rsize = fread(&size, sizeof(long), 1, in); // zalozenie, ze LONG ma 4 bajty
			if (rsize != 1) break;
			buff = (char *) malloc(size + 1);
			tmp = (char *) malloc(size + 10);
			if ((buff == NULL) || (tmp == NULL)) break;

			rsize = fread((void *)buff, sizeof(char), size, in);
			if (rsize != size) break;
			buff[size] = NULL;
			strcpy(tmp, NONE);
			sprintf(tmp, "{%s}", buff);

#ifdef HTML
			parse(tmp, size);
#else
			//printf("%s\n", tmp);
			fprintf(out, "%s\n", tmp);
#endif
			free(buff);
			free(tmp);
			buff = tmp = NULL;
			++line;
		}
		if (buff) free(buff);
		if (tmp) free(tmp);
	} 
		else {
		puts("file [in | out] not found!");
	}
	if (in) fclose(in);
	if (out) fclose(out);
	printf("%d linii\n", line);
	return 0;
}

struct opcode {
	char	a[12];        // czego szumay?
	int	len;          // jaka ma miec dlugosc?
	char	b[30], c[30]; // zamien na znaczniki HTML (b - na poczatku, c - na koncu)
};

void parse(char *text, int size) {
  char ch;
	struct opcode *op, opcodes[] = {
		"\\i0",     3,   "</I>", "",        // pochyle
		"\\i",      2,   "<I>", "</I>",     // pochyle
		"\\b ",     3,   "<B>", "</B>",     // pogrobione
		"\\b0",     3,   "</B>", "",
		"\\b",      2,   "<B>", "</B>",     // pogrobione
		"\\ul0 ",   5,   "</U>", NONE,
		"\\ul0",    4,   "</U>", NONE,
		"\\ul ",    4,   "<U>",  NONE,
		"\\ul",     3,   "<U>",  NONE,
		"\\par\\par", 8, "</B></I><BR><BR>", NONE,
		"\\pard",   5,    NONE,  NONE,       //
		"\\par \n\\par",  10,    NONE, NONE, // nowa linia
		"\\par",    4,   "<BR>", NONE,       // nowa linia
		"\\f0 ",    4,    NONE,  NONE,
		"\\f0",     3,    NONE,  NONE,
		"\\f1 ",    4,    NONE,  NONE,
		"\\f1",     3,    NONE,  NONE,
		"\\f2 ",    4,    NONE,  NONE,
		"\\f2",     3,    NONE,  NONE,
		"\\f3 ",    4,    NONE,  NONE,
		"\\f3",     3,    NONE,  NONE,
		"\\f4 ",    4,    NONE,  NONE,
		"\\f4",     3,    NONE,  NONE,
		"\\f6 ",    4,    NONE,  NONE,
		"\\f6",     3,    NONE,  NONE,
		"\\qc",     3,   "<CENTER>", "</CENTER>",
		//"\\line", 5,    NONE,  NONE,       // nowa linia
		"\\line",   5,   "<BR>", NONE,       // nowa linia
		"\\cf0 ",   5,   "<FONT color=black>", "</FONT>",
		"\\cf0",    4,   "<FONT color=black>", "</FONT>",
		"\\cf1 ",   5,   "<FONT color=red>",   "</FONT>",
		"\\cf1",    4,   "<FONT color=red>",   "</FONT>",
		"\\cf2 ",   5,   "<FONT color=blue>",  "</FONT>",
		"\\cf2",    4,   "<FONT color=blue>",  "</FONT>",
		"\\cf3 ",   5,    NONE,  NONE,
		"\\cf3",    4,    NONE,  NONE,
		"\\cf4 ",   5,    NONE,  NONE,
		"\\cf4",    4,    NONE,  NONE,
		"\\cf5 ",   5,    NONE,  NONE,
		"\\cf5",    4,    NONE,  NONE,
		"\\sa100",  6,    NONE,  NONE,
		"\\li300",  6,    NONE,  NONE,
		"\\super ", 7,   "<SUP>", "</SUP>",   // superscript
		"\\super",  6,   "<SUP>", "</SUP>",   // superscript
		"\\plain",  6,   "<FONT color=black>", "</FONT>",   // superscript
		"\\strike", 7,    NONE,  NONE,
		NULL, NULL, NULL, NULL
	};
	char *outstr,tmpstr[10000];
	const int C_SIZE=(60*1024);

//	levels = malloc(100*sizeof(long));
//	levels[level] = (char *) malloc(1000);
//	outstr = (char *)levels[level];
//	strcpy(outstr, NONE);

	while ((ch = *text) != NULL) {
		// printf("[%x:%c]", ch, ch);

		switch (ch) {
		case '<':
			// znak mniejszosci - przenies do html'a
			fprintf(out, "&lt;");
			break;

		case '>':
			// znak wikszosci - przenies do html'a
			fprintf(out, "&gt;");
			break;

		case '{':	
			// znacznik zagniezdzenia
			//printf("allokuje nowy bufor na poziomie %d\n", level);
			levels[++level] = (char *) malloc(C_SIZE);
			outstr = (char *) levels[level];
			strcpy(outstr, NONE);
			break;

		case '}':
			// koniec znacznika zagniezdzenia
			//printf("zwalniam bufor na poziomie %d\n", level);
			outstr = (char *) levels[level];
			if (outstr) {
				fprintf(out, outstr);
				free(outstr);
				levels[level] = NULL;
			}
			outstr = (char *) levels[--level];
			break;

		case '\n':
			break;
/*
			// koniec linii definicji
			fprintf(out, "%s\n", outstr);
			strcpy(outstr, NONE);
			break;
*/
		case '\\':
			// konwersja znacznika
			op = (struct opcode *)opcodes;
			while (op->len != NULL) {
				if (strncmp(text, op->a, op->len) == 0) {
					fprintf(out, op->b);
					strcpy(tmpstr, op->c);
					strcat(tmpstr, outstr);
					strcpy(outstr, tmpstr);
					text += (op->len - 1);
					break;
				}
				op++;
			}
			break;

		default:
			fprintf(out, "%c", ch);
		}
		++text;
	}
	fprintf(out, "\n");
}

/*
\f0\b\cf0 Aachen \par\par
\f2\b0\cf1 Akwizgran{\plain\f0\cf5 .}\par
\par

\b Aal \f6\b0\i\cf2 m\f0\i0\cf5  \f6\i (-es; -e)\par\par
\f2\i0\cf1 wgorz{\plain\f0\cf5 ;}\par
\f0\i\cf0 Aal- in \f6\cf2 Zssgn\f0\i0\cf5  \f2\cf1 wgorzowy{\plain\f0\cf5 .}\par
\par

\b aalen \f6\b0\cf2 F\f0\cf5 \par\par
\i\cf0 {\plain\f0\cf5 :} sich aalen \f2\i0\cf1 wylegiwa si{\plain\f0\cf5 ;} \par
\f0\i\cf0 in der Sonne aalen \f2\i0\cf1 pawi si{\plain\f0\cf5 .}\par
\par

\b aalglatt\par\par
\f2\b0\cf1 liski jak wgorz{\plain\f0\cf5 ;}\par
\f6\i\cf2 fig.\f0\i0\cf5  \f2\cf1 sprytny{\plain\f0\cf5 ;} \par
przebiegy {\plain\f0\cf5 (}przebiegle{\plain\f0\cf5 ).}\par
\par
*/
